#ifndef _ARRAYH_
#define _ARRAYH_
#ifdef __MWERKS__
#pragma once
#endif


typedef struct sarray {
	char *(*resize)(struct sarray *, long);
	long recsize;
	long numrecs;
	long maxrecs;
	char *data;
} Array, *ArrayPtr ;

typedef struct {
	char *(*resize)(struct sarray *, long);
	long recsize;
	long numrecs;
	long maxrecs;
	char *data;
	long firstfree;
	long numused;
} Pool, *PoolPtr ;

typedef struct {
	long nextfree;
} FreeListNode, *FreeListNodePtr;

extern PoolPtr nodes;
extern PoolPtr derivs;

ArrayPtr NewArray();		
PoolPtr NewPool();		
char *SizeArray();		
char *SizePool();		
char *GetRecordPtr();		
long AddRecords();		
long SubRecords();		
long PushStack();		
long GetFreeRecord();		
long CopyRecord();		

#endif
