#ifndef _ARRAY_PROTO_
#define _ARRAY_PROTO_
#ifdef __MWERKS__
#pragma once
#endif

/* array.c */
char *SizeArray(struct sarray* array, long size);
char *SizePool(struct sarray* array, long size);
ArrayPtr NewArray(long recsize, long maxrecs);
void InitArray(ArrayPtr array, long recsize, long maxrecs);
PoolPtr NewPool(long recsize, long maxrecs);
void InitPool(PoolPtr array, long recsize, long maxrecs);
char *GetRecordPtr(ArrayPtr array, long index);
int GetRecord(ArrayPtr array, long index, char *record);
int GetNRecords(ArrayPtr array, long index, long n, char *record);
int PutRecord(ArrayPtr array, long index, char *record);
int PutNRecords(ArrayPtr array, long index, int n, char *record);
int InsertRecord(ArrayPtr array, long index, char *record);
int InsertNRecords(ArrayPtr array, long index, long n, char *record);
int DeleteRecord(ArrayPtr array, long index, char *record);
int DeleteNRecords(ArrayPtr array, long index, long n, char *record);
long AddRecords(ArrayPtr array, long n);
long SubRecords(ArrayPtr array, long n);
int PushRecord(ArrayPtr array, char *record);
long PushStack(ArrayPtr array);
int PopRecord(ArrayPtr array, char *record);
int DropNStack(ArrayPtr array, long n);
void FreeRecord(PoolPtr array, long index);
void FreePool(PoolPtr array);
void DumpPool(FILE *file, PoolPtr array);
long GetFreeRecord(PoolPtr array);
long CopyRecord(PoolPtr array, long index);
void memorymove(char *s1, char *s2, long len);

#endif
