#ifndef _HOUSE_PROTO_
#define _HOUSE_PROTO_
#ifdef __MWERKS__
#pragma once
#endif

#include <stdio.h>

/* house.c */
int rowptr(int i);
int colptr(int i);
char *MemAlloc(char *s, long size);
char *Reallocate(char *s, long size, char *x);
void freemem(char *s, char *ptr);
double LSB(void);
int CountVars(int type);
void DumpColNames(void);
int GetDeltaValue(int k, char **name, short *index, int *type, double *value);
int GetDeltaParams(int k, char **name, short *index, int *type, double *value);
int getcolumn(int type, char *name, short *indices);
double getdeltas(int type, char *name, short *i);
void PrintMatrix(void);
void PrinttheMatrix(int begin, int end, int colwid);
void PrintResults(void);
void InitHouse(char *s, int PrintVal, double Tolerance);
void ReserveSpace(void);
void rowspace(void);
void colspace(void);
void matspace(void);
double *rowallocate(void);
double *rowreallocate(char *Pointr);
void filecheck(char *s);
void SumInit(int eqtype);
void SumAdd(int type, char *name, short i[5 ], double x);
void SwitchCol(int i, int j);
int Modulus(int Col, int i);
void SortPivotColumn(int ThisCol);
void ApplyConstraintTransform(int column);
void ApplyHouseholderTransform(int column);
void ApplyTransformation(int ThisCol);
void CalculateModuli(void);
void CalculateColumnSum(void);
void CalculateRowSum(void);
double TypeModulus(int i);
double NameModulus(int i);
double CCModulus(int i);
double CompareCol(int i, int j);
void FindPivotColumn(int ThisCol);
double sign(double dvalu);
void SolveLinearSystem(void);
void SumIt(void);
void CovarianceMtx(void);
int getindexsz(void);
int getmaxprmname(void);
int getdimnum(void);
void Solve1(void);
void SolveMatrix(void);
void triangularize1(void);
void triangularize(void);
void insertresidual(double x);
int Get_LastCol(void);
double Get_Sigma(void);
void ChiSquare(void);
void freecolspace(void);
void freerowspace(void);
void freematspace(void);

#endif
