/* ImitationMIDAS table routines */

#include "cjoin.h"
#include <stdio.h>
#include <math.h>
#include "strings.h"
#include <ctype.h>
#include "defines.h"
#include "def.h"


static int lastcol= 0;
static int lastrow;
double expan[4] =	    {
	1.5,1.33333,1.25,1.2}; /*series for row reallocation*/
char  *strcpy();
char cword[LSTRLEN] = "blank";

static int skip1, skip2,numcol,nrows,nrows1,nrows2,ncols,onefile;
static char fname[3][26];
char   **charrow;


int  *scol;

MIDAS *midasclose(tabla,outtabla) /* close midas table*/
MIDAS *tabla;
char *outtabla;
{
	FILE *fp2;
	int  i,j,num;
	char *result,ans[STRLEN];

	j = 0;
	if(tabla) /* see	if it's open */
	{
		if(!(fp2=fopen(outtabla,"w"))) /* open file     for writing */
			fatalerror("Can't open output file: %s\n",tabla->fname);

		for(i=0;i<nrows;i++) /* do   for each row */
		{
		  for(j=0;j<numcol;j++) /* print out each entry in the row */
		  {
						if (scol[j] < ncols)
				printchars(fp2,tabla,i,scol[j]);
		  }
		  fprintf(fp2,"\n");
		}

		fflush(fp2); /* flush the file before closing */
		fclose(fp2); /* close file */
		if ((num= strcmp(outtabla,tabla->fname)) == 0)
		{
			freethestructure(tabla);
			lastrow = MIDASROWS;
			lastcol = 0;
		}
				printf("\nFinished!\n");
		return NULL;
	}
	else
		fatalerror("Could not close data file that was never opened: %s\
n",tabla->fname);
}


printchars(fp,tabla,i,j)
FILE *fp;
MIDAS *tabla;
int i,j;
{
	int num;

	fprintf(fp,"%s\t",tabla->cvalue[i][j]);
}





freethestructure(tabla)
MIDAS *tabla;
{
	freethespace((char*)tabla->cvalue); /* discard allocated space */
	freethespace((char*)tabla); /* free allocated space */
}

freethespace(name)
char *name;
{
	/*if (name != NULL)
	{
		freespace(name);
		name = NULL;
	}*/
}


addspace(tabla)
MIDAS *tabla;
{
	static  int m;
		int i, j,old;

		old = tabla->rows;
	if (m>3 || m<0)
		m = 0;
	tabla->rows = (int)((float)tabla->rows*(expan[m])); /* reallocate usin
g series for max efficiency */
		if ((tabla->rows - old) < 10)
			tabla->rows = tabla->rows + 10;
	rowrealloc(tabla); /* reallocate the rows: add rows */
		lastrow = tabla->rows;
	m++;

}


makespace(tabla) /* initial space allocation    for table */
MIDAS *tabla;
{
	int dvalsz,cvalsz,namesize;
	int i;

	cvalsz = MIDASROWS * sizeof(char***) +8; /* size of     cvalue */
	tabla->cvalue = (char***)MemAlloc("cvalue",cvalsz);

}

char **charalloc(csize) /* allocate space       for a   char string row */
int csize;
{
	char **x;
	int i;
	int size;

	/* size of array of     character strings */
	size = csize*sizeof(char**) + 8;
	x = (char**)MemAlloc("charrow",size);
	for (i=0;i < csize; i++)
	{
		*(x+i) = "0";
	}
	return x;
}


MIDAS *join_open(ifname,ifname1,ofname) /* open astrometry table */
char *ifname,*ofname,*ifname1;
{
	FILE *fp,*fp1;
	MIDAS *tabla;

	onefile = 0;

	/* load file names into global */
	strcpy(fname[0],ifname);
	strcpy(fname[1],ifname1);
	strcpy(fname[2],ofname);
	if (strcmp(ifname1,"0") == 0)
		onefile = 1;

	if(!(fp = fopen(fname[0],"r"))) /* try to open the file */
		fatalerror("Data File %s Does Not Exist\n",fname[0]);
	if (!onefile)
	{
		if(!(fp1 = fopen(fname[1],"r"))) /* try to open the file */
			fatalerror("Data File %s Does Not Exist\n",fname[1]);
	}
	else
		fp1 = NULL;
	tabla = (MIDAS*)MemAlloc("MIDASFP",sizeof(MIDAS)+18);
	strcpy(tabla->fname,fname[2]); /* copy file name  into table header */
	join_fread(fp,fp1,tabla); /* read fitslike data into table */
	return tabla; /*	return table pointer */
}


join_fread(fp,fp1,tabla)
/* load position mode info into table */
MIDAS *tabla;
FILE *fp,*fp1;
{
	int i,j,k,c, num,num1, numrow,l;
	int fw1;
	char *result;
	char line[MAXLIN],*lineptr, word[LSTRLEN], **charalloc();
	char ans[STRLEN], line2[MAXLIN];
	char  hline[HUGELIN],hline2[HUGELIN];
	int start;

	skip1 = -1;
	skip2 = -1;
	tabla->rows =MIDASROWS; /*initially set number of rows to MIDASROWS */
	tabla->cols =MIDASCOLS; /*initially set number of cols to MIDASCOLS */
	lastrow = tabla->rows;


	makespace(tabla); /* allocate space */
	numrow = MIDASROWS;

	/*  go ahead and allocate the  midasrows necessary */
	for (i=0; i<numrow; i++)
		{
	     charrow =charalloc(tabla->cols);
	     *(tabla->cvalue+i) = charrow;
	}


	/* check to see if lines need to be skipped */

	printf("\nSkip lines at beginning of file: %s (Y/N)?\n", fname[0]);
	result = gets(ans);
	if ((strcmp(ans,"Y")==0) || (strcmp(ans,"y")==0))
			skip1 = skiplines(fp);

	if (!onefile)
	{
		printf("\nSkip lines at beginning of file: %s (Y/N)?\n", fname[1]);
		result = gets(ans);
		if ((strcmp(ans,"Y")==0) || (strcmp(ans,"y")==0))
			skip2 = skiplines(fp1);
	}


	/*  present columns - query which to output */

	getcols(fp,fp1,tabla);

	/* read in data from each file */
	nrows1 = 0;
	nrows2 = 0;
	while ((result = fgets(line,MAXLIN-1,fp)) != NULL) /* get line */
	{
			ncols = 0;
	     while ((lineptr = getword(line,word)) != NULL)
		{
			strcpy(line,lineptr);
			if (nrows1 >= lastrow)
				addspace(tabla);
			/* load word into table */
			tabla->cvalue[nrows1][ncols]=  wordalloc(word);
			ncols++;
		}
			nrows1++;
	}
	start = ncols;

	if (!onefile)
	{
		while ((result = fgets(line,MAXLIN-1,fp1)) != NULL) /* get line */
		{
			ncols = start;
	   		while ((lineptr = getword(line,word)) != NULL)
	    	{
		   		strcpy(line,lineptr);
				if (nrows2 >= lastrow)
					addspace(tabla);
		   		/* load word into table */
		   		tabla->cvalue[nrows2][ncols]=  wordalloc(word);
		   		ncols++;
			}
			nrows2++;

		}
	}
	nrows = maxval(nrows1,nrows2);
	if (!onefile)
		if (nrows1 != nrows2)
			warningerrori2("File: %s has %d rows, File: %s has %d rows. Zero fill will occur\n",fname[0],nrows1,fname[1],nrows2);
	fflush(fp); /* flush the file before closing */
	if (!onefile)
		fflush(fp1); /* flush the file before closing */
	fclose(fp);
	if (!onefile)
		fclose(fp1);
}

skiplines(fp)
FILE *fp;
{
	int j,minv,minimum,mini,i,skip,num;
	char hline[HUGELIN],line[SCRNLIN],minis[STRLEN];
	char *result;

	skip = -1;

	while (skip < 0)
	{
		printf("Approximately how many lines to skip?:\n");
		gets(minis);
		sscanf(minis,"%d",&mini);
		minimum = mini-5;
		if (minimum <0)
			minimum = 0;

		printf("\n");

		for (i = 0; i < minimum; i++)
			result = fgets(hline,HUGELIN-1,fp);
		for (i = minimum; i < mini+5; i++)
		{
			result = fgets(hline,HUGELIN-1,fp);
			if (result != NULL)
			{
				num = strlen(hline)+1;
				minv = minval(num,SCRNLIN);
				strncpy(line,hline,minv-1);
				line[minv-1] = 0;
				printf("%d: %s\n",i+1,line);
			}
			else
				printf("%d: past end of file \n",i+1);
		}
	
		printf("\nHow many lines to skip?(-1 to select again):\n");
		gets(minis);
		sscanf(minis,"%d",&skip);
		rewind(fp);
	}
	return skip;

}

rowrealloc(tabla)/* reallocate space of	double pointer array */
MIDAS *tabla;
{
	int i;
	long newsize=0;
	if (tabla->cvalue != NULL)
	{
		/* size of new	char pointer	chararray */
		newsize = (long)(tabla->rows*sizeof(char*)+8); 

		/* reallocate space */
		tabla->cvalue=(char***)Reallocate("cvalue",newsize,(char*)tabla->cvalue);
		if (tabla->cvalue== NULL) /* test space */
			fatalerror("Memory Manager Error in row reallocation --MIDAS file %s\n", tabla->fname);
		for (i=lastrow; i<tabla->rows; i++)
		{
			  charrow =charalloc(tabla->cols);
			  *(tabla->cvalue+i) = charrow;
		}			
	}
}

getcols(fp,fp1,tabla)
FILE *fp, *fp1;
MIDAS *tabla;
{
	int i,j,k,c, l, sumwidth;
	int fw1,width[MIDASCOLS];
	char *result;
	char aword[MIDASCOLS][LSTRLEN], numword[MIDASCOLS][MSTRLEN];
	char line[MAXLIN], *lineptr, word[LSTRLEN];
	char cols1[MAXLIN];
	char  hline[HUGELIN],hline2[HUGELIN];


	for (i = 0; i <skip1; i++)
	{
		result = fgets(hline,HUGELIN-1,fp);
		if (result == NULL)
			fatalerror("No data exists in file %s\n", fname[0]);
	}

	if (!onefile)
	{
		for (i = 0; i <skip2; i++)
		{
			result = fgets(hline2,HUGELIN-1,fp1);
			if (result == NULL)
				fatalerror("No data exists in file %s\n", fname[1]);
		}
	}


	fw1 = 0;
	for (i = 0; i < MIDASCOLS; i++)
	{
			strcpy(aword[i]," ");
			strcpy(numword[i]," ");
			width[i] = 0;
	}

	result = fgets(hline,HUGELIN-1,fp);
	while ((lineptr = getword(hline,word)) != NULL)
	{
		strcpy(aword[fw1],word);
		width[fw1] = strlen(word)+3;
		strcpy(hline,lineptr);
		fw1++;
		if (fw1 > MIDASCOLS)
					fatalerrori("More columns (%d) in data files than space allocated.  Change \nMIDASCOLS in cjoin.h to higher value\n", fw1);
	}



	if (!onefile)
	{
		result = fgets(hline2,HUGELIN-1,fp1);
		while ((lineptr = getword(hline2,word)) != NULL)
		{
			strcpy(aword[fw1] , word);
			width[fw1] = strlen(word)+3;
			strcpy(hline,lineptr);
			strcpy(hline2,lineptr);
			fw1++;
			if (fw1 > MIDASCOLS)
				fatalerrori("More columns (%d) in data files than space allocated.  Change \nMIDASCOLS in cjoin.h to higher value\n", fw1);
		}
	}

		if (fw1 > MIDASCOLS)
			fatalerrori("More columns (%d) in data files than space allocated.  Change \nMIDASCOLS in cjoin.h to higher value\n", fw1);
	i = 0;
	k = 0;

	while (i <fw1)
	{
		sumwidth = 0;
		j = 0;
		while ((sumwidth < 70) && (i <fw1))
		{
			if (i <fw1)
				printf("%*d", width[i],i+1);
			sumwidth = sumwidth +width[i];
			if ((sumwidth +width[i+1]) > 75)
				sumwidth = 75;
			i++;
			j++;
		}
		printf ("\n");
		for (l = 0; l < j; l++)
		{
			printf("%*s", width[k],aword[k]);
			k++;
		}
		printf ("\n\n");
	}

	/* Get columns to output */

		ncols = fw1;	
	printf("Select columns in order of output(-1 for all):\n");
	result = gets(cols1);
	c = 0;



	while ((lineptr = getword(cols1,word)) != NULL)
	{
		strcpy(numword[c] , word);
		strcpy(cols1,lineptr);
		c++;
	}

	if ((scol=(int*)MemAlloc("scol",c*sizeof(int))) == NULL)
	   fatalerror("Memory Manager Error in scol--file %s\n",tabla->fname);

	for (i = 0; i< c; i++)
		{
		sscanf(numword[i],"%d",&scol[i]);
				scol[i] = scol[i] - 1;
		}
	numcol = c;

		if (scol[0] <0 )
		{
		if ((scol=(int*)MemAlloc("scol",ncols*sizeof(int))) == NULL)
	   		fatalerror("Memory Manager Error in scol--file %s\n",tabla->fname);
			for (i = 0; i<ncols; i++)
				scol[i] = i;
			numcol = i;
		}

		ncols = fw1;	
		for (i = 0; i < numcol; i++)
		{
			if (scol[i] > ncols)
		warningerrori("Selected column exceeds columns in file: %d. It will be ignored. \n ", scol[i]+1 );

		}

	/* rewind input files */
	rewind(fp);
	if (!onefile)
		rewind(fp1);

	for (i = 0; i <skip1; i++)
		result = fgets(hline,HUGELIN-1,fp);

	if (!onefile)
	{
		for (i = 0; i <skip2; i++)
			result = fgets(hline2,HUGELIN-1,fp1);
	}
}
