/* ImitationTABLE table routines */

#include "prototypes.p"
#include <string.h>
#include <ctype.h>




void resid_open(char *fname)
{
	FILE *fp, *fpo;
	char ofname[40];


	put_name(fname);
        strcpy(ofname,fname);
        strcat(ofname,".rms");

	if(!(fp = fopen(fname,"r"))) /* try to open the file */
		fatalerror("Input  File %s Does Not Exist\n",fname);
	if(!(fpo = fopen(ofname,"w"))) /* try to open the file */
		fatalerror("Output  File %s cannot be opened. \n",ofname);
	in_fread(fp,fpo,fname); /* read columnar data into table */
}


void in_fread(FILE *fp, FILE *fpo,  char *fname)
{

	int res, num;
	char *resc;
	char line[MAXLIN],*lineptr, word[LSTRLEN], lets[200][LSTRLEN];
	char *s;
	char string[25];
	int  column,col,item;
	int set;
	int xres, yres;
	int howmany;
	char target[LSTRLEN*3];
	double X2[50], Y2[50];
	char *resX  , *resY;
	char xresname[20], yresname[20];

	item = 0;
	res= 1;

	strcpy(word,"blob");




	if ((lineptr=MemAlloc("lineptr",(size_t)sizeof(MAXLIN))) == NULL)
				fatalerror("Memory Manager Error in lineptr--file %s\n", 
					fname);

	resc=fgets(line,MAXLIN-1,fp);
	col = 0;
	xres=yres= -1;

	strcpy(xresname,"blob");
	strcpy(yresname,"blob");

   	while   ((lineptr = getword(line,word) ) != NULL)
	{
		strcpy(line,lineptr);
		if (((resX = strstr(word,"_X")) != NULL) ||
		    ((resX = strstr(word,"_x") )!= NULL))
				strcpy(xresname,word);
		if (((resY = strstr(word,"_Y")) != NULL) ||
		    ((resY = strstr(word,"_y")) != NULL))
				strcpy(yresname,word);
	}


	
	if (num = strcmp(xresname,"blob") == 0)
		getfilename("\nEnter name of X residual: ",xresname);
	if (num = strcmp(yresname,"blob") == 0)
		getfilename("\nEnter name of Y residual: ",yresname);
	rewind(fp);
	resc=fgets(line,MAXLIN-1,fp);

   	while   ((lineptr = getword(line,word) ) != NULL)
	{
		strcpy(line,lineptr);
		/* find xres column*/
		if (num = strcmp(word,xresname) == 0)
			xres = col;
		/* find yres column */
		if (num = strcmp(word,yresname) == 0)
			yres = col;
		col++;
	}

		
	if (xres == -1)
			fatalerror2s("%s  not found in file. File: %s.\n",xresname,fname);
	if (yres == -1)
			fatalerror2s("%s  not found in file. File: %s.\n",yresname,fname);

	/* find most corrected x point */
	/*printf("xresname = %s, col = %d\n",xresname,xres);
	printf("yresname = %s, col = %d\n",yresname,yres);*/

	/* skip type line if it is there*/
	resc=fgets(line,MAXLIN-1,fp);
   	lineptr = getword(line,word);
	if ((num = strcmp(word,"double") != 0) && (num = strcmp(word,"char") != 0))
	{
		rewind(fp);
		resc=fgets(line,MAXLIN-1,fp);
	}

	while((resc=fgets(line,MAXLIN-1,fp)) != NULL)/* get line from file */
	{
		column = 0;
		if ((howmany = loadwords(line,lets))  >= col )
		{ 	
			sscanf(lets[xres], "%lf",&X2[item]);
			sscanf(lets[yres], "%lf",&Y2[item]);
			column++;
		}
		else
			fatalerror("Not enough columns in file: \n",fname);



	item++;
	}

	do_math(X2, Y2,item,fpo,fname);


	fflush(fpo); /* flush the file before closing */
	fclose(fpo);
}

void do_math(double *X2, double *Y2,int item,FILE *fpo,char *fname)
{
	int i;
	double sumx, sumy, sumxy, maxx, maxy,rss, Xsqr, Ysqr;
	double xrms, yrms;

	sumx = 0;
	sumy = 0;
	sumxy = 0;
	maxx = 000;
	maxy = 000;

	for (i = 0; i < item; i++)
	{
		Xsqr = X2[i]*X2[i];
		Ysqr = Y2[i]*Y2[i];
		sumx = Xsqr + sumx;
		sumy = Ysqr + sumy;
		sumxy =  sqrt(Xsqr + Ysqr) + sumxy;
		if (fabs(X2[i]) > fabs(maxx)) maxx = X2[i];
		if (fabs(Y2[i]) > fabs(maxy)) maxy = Y2[i];
	}

	xrms = sqrt(sumx/item);
	yrms = sqrt(sumy/item);
	rss = sumxy/item;


	printf("File:%s\n", fname);
	printf("Number of Residuals: %d\n",item);
	printf("Xrms: %lf\tXmax: %lf\n",xrms,maxx);
	printf("Yrms: %lf\tYmax: %lf\n",yrms,maxy);
	printf("rss: %lf\n", rss);

	fprintf(fpo,"File:%s\n", fname);
	fprintf(fpo,"Number of Residuals: %d\n",item);
	fprintf(fpo,"Xrms: %lf\tXmax: %lf\n",xrms,maxx);
	fprintf(fpo,"Yrms: %lf\tYmax: %lf\n",yrms,maxy);
	fprintf(fpo,"rss: %lf\n", rss);


}


