static int CountErrors = 0;
static int DontDump =0;

/*
 GaussFit - A System for Least Squares and Robust Estimation

	Source Code Copyright (C) 1987 by William H. Jefferys,
	Michael J. Fitzpatrick and Barbara E. McArthur
	All Rights Reserved.
*/


#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "alloc.h"
#include "house.h"
#include "array.h"
#include "datum.h"
#include "simpledefs.h"
#include "gffiles.h"
#include "prototypes.p"
#include "symboltable.h"
#include "defines.h"
#ifdef THINK_C
#include <Files.h>
#endif
#include "alloc.h"

#include "files.proto.h"
#include "gfprint.proto.h"
#include "house.proto.h"
#include "precision.proto.h"
#include "errhandle.proto.h"
#include "simplefits.proto.h"
#include "simplermidas.proto.h"
#include "matrixman.proto.h"
#include "util.proto.h"
#include "minsum.proto.h"
#include "quicksort.proto.h"
#include "logicops.proto.h"
#include "xprintf.proto.h"

#ifdef THINK_C
#define WIDTH  60
extern unsigned char *CtoPstr();
#else
#define WIDTH  120
#endif

extern double envhuber, envtukey, envfair, envtrim;
extern int iterno,envdbg, envminsum, envirls, envorm, envprec;
extern int		PrintFlag;	/* Print intermediate results */
extern int		LastCol;	/* Last column active in matrix */
extern FILE *fp,*fpc,*fpcv;
extern int *RowPtr;	/* RowPtr matrix */
extern int *ColPtr;	/* ColPtr matrix */
extern int *rowtype;	/* Type of each row (condition, constraint) */
extern int *coltype;	/* Type of each col (parameter,indexed parameter, right hand side) */
extern short (*number)[5];	/* index of a columns parameter */
extern double *condmodulus;/* modulus of condition eqns in a column */
extern double *constmodulus;/* modulus of condition eqns in a row */
extern double *condtest;	
extern double *consttest;
extern double *deltap;	/* vector of parameter corrections */
extern double *vector;	
extern double *colvec;	
extern double *sigvec;	
extern double *sigval;	

extern int matcol;
extern int matrow;

extern MEMSIZE matsize; /* pointer to current matrix size */

extern int		LastNonzero;	/* Last possible pivot row */
extern int		CurrentRow;	/* The row being eliminated */
extern int		Recalculate;	/* Flag to recalculate moduli */
extern int		LastCol;	/* Last column active in matrix */
extern double	Tol;			/* Acceptable Tolerance */
extern int		PrintFlag;	/* Print intermediate results */
extern int		LastRow;	/* Last row active in matrix */
extern int		FirstPivots;	/*	0 = pivot plates first;
									1 = pivot stars first;
								   -1 = let program choose pivots */
extern int		Constraints;	/* Number of constraints entered */
extern int		Touched;	/* Whether more info has been added */
extern int 		noindex;   /* there are no indexed parameters */
extern int 		lbl;       /*  the indexes are large; put out line by line*/
extern double	DOF;			/* Count of Degrees of Freedom */
extern double	NEQN;			/* Count of Eqs of Condition */
extern double Sigma;				/* Current value of Sigma */
extern double Sigma1;				/* (extern) Current value of Sigma1 */
extern double Sigma1Sq;			/* (extern) Current value of Sigma1Sq */
extern double SumRho;			/* (extern) Running Sum for Rho */
extern double SumPsi;			/* (extern) Running Sum for Psi */
extern double SumPsiSq;			/* (extern) Running Sum for PsiSq */
extern double SumPsiP;			/* (extern) Running Sum for PsiP */
extern double SumPsiPSq;			/* (extern) Running Sum for PsiPSq */
extern double ScaleFac;			/* (extern) ScaleFac */
extern double DeltaV;			/* (extern) Largest Residual Change */
extern double ChiSqr;                 /* Chi Square for real variances*/
extern int		StartAt;	/* Column to start pivoting */
extern int		firstprint; /* for printing out doubles */
extern char **varname;
extern double **matrix;	/* Matrix for Eqns of Condition	 */
extern INDEX *indexarray;

void
PrintMatrix(void) 
{			/* Print current matrix of eqns of condition */
	int i, begin, width,inc;
	int colwid;

	colwid = getmaxprmname();
	if (colwid <6) colwid = 6;
	width = (WIDTH-colwid)/(colwid+2);

	if (PrintFlag /*&& Touched*/) { /* Only print if matrix has been altered */
				 /* and user wants it */
		begin = 0;
		inc = width;
		i = 1;
		while (inc < LastCol) {
			PrinttheMatrix(begin,inc,colwid);
			i++;
			begin = inc + 1;
			inc = i * width;
		}
		PrinttheMatrix(begin,LastCol,colwid);
	}
}

void
PrinttheMatrix(int begin, int end, int colwid)
{
	int i, j,ndim;
	double matint;

	xprintf(fp,"%*s  ",colwid," ");
	for (j = begin;j<=end;j++)	/* print column number */
		xprintf(fp,"%*d  ",colwid,colptr(j));	
	xprintf(fp,"\n");

	xprintf(fp,"%*s  ",colwid,"Type");		/* print name of row */
	for (j = begin;j<=end;j++)	/* print each item of vector */
		xprintf(fp,"%*d  ",colwid,coltype[colptr(j)]);
	xprintf(fp,"\n");		/* print carriage return */

	xprintf(fp,"%*s  ",colwid,"Name");	/* print name of each variable*/
	for (j = begin;j<=end;j++)
		xprintf(fp,"%*s  ",colwid,VarName(j));
	xprintf(fp,"\n");

	ndim = getdimnum();
	for (j = 0; j<ndim; j++) {
		if (j == 0)
			xprintf(fp,"%*s  ",colwid,"Index");	
		else
			xprintf(fp,"%*s  ",colwid," ");
		for(i=begin;i<end;i++)	{
			if(Number(i,4) != 0) {
				prSIndex(fp,NumberX(i),colwid,j);
				xprintf(fp, "  ");
			} 
			else{
				xprintf(fp,"%*s", colwid,"");
				xprintf(fp, "  ");
			}
		}
		xprintf(fp,"\n");
	}

	xprintf(fp,"\n");
	xprintf(fp,"\n");
	for (i = 0;i<=LastRow;i++)	/* print each row of matrix */
	{
		/* print row number and type */
		xprintf(fp,"%*d%*d  ",(colwid/2),rowptr(i), (colwid/2),RowType(i)); 
		for (j = begin;j<=end;j++) /* print normalized matrix entry */
		{
			matint = 100.0* Matrix(i,j);
			if (fabs(matint) < 1.0E9)
				xprintf(fp,"%*d  ",colwid,itrunc(matint));
		}
		xprintf(fp,"\n");
	}
	xprintf(fp,"\n");
}

void
PrintResults(void)			/* Print results of iteration */
{
	int i;

	fflush(fp);			/* flush out buffer fo results file */ 
	PrintMatrix();		/* Print the condition eqn matrix */
}


void
printcopyright(FILE *fp)
{
	xprintf(fp,"*********************************************");
	xprintf(fp,"***********************************\n\n");
	xprintf(fp,"GaussFit - A System for Least Squares and Robust Estimation\n\n");
	xprintf(fp,"Copyright (C) 1987-2001 by \n");
	xprintf(fp,"Barbara E. McArthur, William H. Jefferys, \n");
	xprintf(fp,"James McCartney,and Mike Fitzpatrick\n");
	xprintf(fp,"All Rights Reserved. Version 3.55  LINUX \n");
	xprintf(fp,"\n*********************************************");
	xprintf(fp,"***********************************\n\n");
}

void
printiter_results(FILE *fp, double KFAC)
{
		xprintf(fp,"scale     =\t");
		printdouble(fp,ScaleFac,0);
		xprintf(fp,"\n");
		xprintf(fp,"SumRho    =\t");
		printdouble(fp,SumRho,0);
		xprintf(fp,"\n");
		xprintf(fp,"SumPsi    =\t");
		printdouble(fp,SumPsi,0);
		xprintf(fp,"\n");
		xprintf(fp,"SumPsiSq  =\t");
		printdouble(fp,SumPsiSq,0);
		xprintf(fp,"\n");
		xprintf(fp,"SumPsiP   =\t");
		printdouble(fp,SumPsiP,0);
		xprintf(fp,"\n");
		xprintf(fp,"SumPsiPSq =\t");
		printdouble(fp,SumPsiPSq,0);
		xprintf(fp,"\n");
		xprintf(fp,"KFAC      =\t");
		printdouble(fp,KFAC,0);
		xprintf(fp,"\n");
		xprintf(fp,"Sigma     =\t");
		printdouble(fp,Sigma,0);
		xprintf(fp,"\n");
		xprintf(fp,"\n");
}

void
PrintCMatrix(FILE *fptr, int start, int end, int indsize, int colwid, int mxprnam, int mult, int type)
{
	int i,j,ndim;
	double	div,matint;

	ndim = getdimnum();
	xprintf(fptr,"\n");
	if (type == 0) /* then it's a correlation matrix */
		xprintf(fptr, "Correlation Matrix * %d\n",mult);
	else		/* then it's a covariance matrix */
		xprintf(fptr, "Covariance Matrix\n");
	xprintf(fptr,"\n");

	if (noindex)
		xprintf(fptr,"%*s\t",mxprnam," ");
	else
		xprintf(fptr,"%*s\t",mxprnam+indsize," ");

	for(i=start;i<end;i++)	
		xprintf(fptr,"%*s\t", colwid,VarName(i));
	xprintf(fptr,"\n");

	if ((!noindex)  && (!lbl)){
		xprintf(fptr,"%*s\t",indsize+mxprnam," ");
		for(i=start;i<end;i++)	{
			if(Number(i,4) != 0) {
				prIndex(fptr,NumberX(i),indsize);
				xprintf(fptr, "\t");
			} else {
				xprintf(fptr,"%*s", indsize," ");
				xprintf(fptr, "\t");
			}
		}
		xprintf(fptr,"\n");
	}

	if ((!noindex)  && (lbl)) {
		for (j = 0; j<ndim; j++) {
			xprintf(fptr,"%*s ",indsize+mxprnam," ");
			for(i=start;i<end;i++)	{
				if(Number(i,4) != 0) {
					prSIndex(fptr,NumberX(i),colwid,j);
					xprintf(fptr, "\t");
				} 
				else{
					xprintf(fptr,"%*s", colwid,"");
					xprintf(fptr, "\t");
				}
			}
			xprintf(fptr,"\n");
		}
	}
	xprintf(fptr,"\n");

	for(i=0;i<LastCol;i++) {
		if ((Number(i,4) == 0) && (noindex==1)) {
			xprintf(fptr,"%*s\t", mxprnam,VarName(i));
			}
		else if ((Number(i,4) == 0) && (noindex==0)){
			xprintf(fptr,"%*s", mxprnam,VarName(i));
			xprintf(fptr,"%*s", indsize," ");
			xprintf(fptr,"\t");
			}
		else {
			xprintf(fptr,"%*s",mxprnam,VarName(i));
			prIndex(fptr,NumberX(i),-indsize);
			xprintf(fptr,"\t");
		}
		for(j=start;j<end;j++) {	/*print the values now */
	 		div =  (sqrt(Matrix(i,i)* Matrix(j,j)));
			if (notzero(div)) {
				matint = (double)mult * (Matrix(i,j)/div);
			}
			if (type == 0) { /* it's a correlation matrix */
				if (i >j) {
					xprintf(fptr,"%*s\t", colwid,"");
				} else {
					if (fabs(matint) < 1.0E9) {
						if (mult >10)
	 						xprintf(fptr,"%*d\t",colwid,(int)matint);
						else
	 						xprintf(fptr,"%le\t",matint);
					}
				}
			} else { /* it's a covariance matrix */
				if (i >j) {
					matint = (double)mult * (Matrix(j,i)/div);
	 				xprintf(fptr,"%le\t",matint*sigval[i]*sigval[j]);
				} else {
	 				xprintf(fptr,"%le\t",matint*sigval[i]*sigval[j]);
	 			}
		 	}
		}
		xprintf(fptr,"\n");
	}
	xprintf(fptr,"\n");
}



void
prSigma(int indsize, int mxprnam)
{
    int i,j;
	short snum[5];

	xprintf(fp,"\n");
	xprintf(fp, "Sigma Values \n");
	xprintf(fp,"\n");
	for(i=0;i<LastCol;i++) {
		if ((Number(i,4) == 0) &&(noindex))
			xprintf(fp,"\tSigma %*s   ", mxprnam,VarName(i));
		else if ((Number(i,4) == 0) &&(!noindex))
			xprintf(fp,"\tSigma %-*s", mxprnam+indsize,VarName(i));
		else {
			xprintf(fp,"\tSigma %*s",mxprnam,VarName(i));
			prIndex(fp,NumberX(i),-indsize);
			xprintf(stdout, "   ");
		}
		sigval[i] = (sqrt(Matrix(i,i)))*(1.0/colvec[i]);
		xprintf(fp," %20.15le\n",sigval[i]);
		for (j=0;j<5; j++)
			snum[j] = Number(i,j);
		load_sigmas(VarName(i),snum,sigval[i]);
	}
}

void
prIndex(FILE *fd, short indx[5 ], int indsize)
{
	int i;
	char string[100];
	char tiny[10];

	/*
	if (indx[4] < 1 || indx[4] > 4) {
		xprintf(stderr, "\nprintIndex: Number of dimensions = %d\n",indx[4]);
		exit(-1);
	}
	*/
	strcpy(string,"[");
	for (i=0; i<indx[4]; ++i) {
		if (i!=0) strcat(string, ",");
		sprintf(tiny, "%d",indx[indx[4]-1-i]);
		strcat(string,tiny);
	}
	strcat(string, "]");
	xprintf(fd,"%*s",indsize,string);
}


void
prSIndex(FILE *fd, short indx[5 ], int indsize, int level)
{
	int i;
	char tiny[10];

	if (indx[4] < 1 || indx[4] > 4) {
		xprintf(stderr, "\nprintIndex: Number of dimensions = %d\n",indx[4]);
		fatalerror("","");
	}
	sprintf(tiny, "[%d]",indx[indx[4]-1-level]);
	xprintf(fd,"%*s",indsize,tiny);
}

void
printdouble(FILE *fp, double dvalue, int preon)
{
	double floor() ;
	double truncnum,diffround,tnum;
	char dnum[30],dnum2[30];
	int i, j;
	static int prec = 18;
	static int file_prec = 18;
	static int maxi = 0;
	static double two_thirds;


	if ((dvalue < UUND) && (dvalue > LUND))
	{
		xprintf(fp,"#N/A\t");
		return;
	}

	if (firstprint)
	{
		firstprint = 0;
		prec = envprec;
		file_prec = machine_prec();
		two_thirds = 0.66 * file_prec;
		if ((file_prec < 14) || (file_prec >  30))
			file_prec  = DBL_DIG;
		if ((prec < 4) || (prec >  30))
			prec  = file_prec;
	}
 
	if ((prec != file_prec) && (preon == 0))
		xprintf(fp,"% .*g\t",prec,dvalue);
	else
 	{
		if (((fabs(dvalue) < 1.0E-10) || (fabs(dvalue) > 1.0E+9))
			&& (dvalue != 0.0))
			xprintf(fp,"% .*e\t",file_prec,dvalue);
		else
		{
			sprintf(dnum,"% .*f",file_prec,dvalue);
			i = strlen(dnum)-1;
			if (i > maxi) maxi = i;
			if (DBL_DIG < i) i = DBL_DIG;
			if ((dnum[i] != '0') && (dnum[i-1] == '0'))
				i--;
			while (dnum[i] == '0')	
				i--;
			i++;
			if (dnum[i-1] == '.') i++;
			if (dvalue < 0.0) i++;
			dnum[i] = '\0';
			if (i > (int)two_thirds)
				{
				xprintf(fp,"%-*s\t",maxi,dnum);
				}
			else
				{
				xprintf(fp,"%-s\t",dnum);
				}
		}
	}
}


void
dump(char *s)
{
	int i, j,k,l;
	int collimit, rowlimit;

	if(DontDump)
		return;
	if(CountErrors>100)
		return;
	CountErrors++;
	xprintf(fp,s);
	xprintf(fp,", Entry # %d\n",CountErrors);
	collimit = matsize.ncols;
	rowlimit = minval(LastRow,30);
	xprintf(fp,"Matrix\n");
	for (j = 0; j <collimit; j++)
		xprintf(fp,"%3d ",j);
	xprintf(fp,"\n");
	for (i = 0; i <rowlimit; i++)
	{
		xprintf(fp,"%7d",i);
		for (j = 0; j <collimit; j++)
		{
			xprintf(fp,"%7.3f",Matrix(i,j));
		}
		xprintf (fp,"\n");
	}
	xprintf (fp,"\n");

	xprintf(fp,"RowType\n");
	for (i = 0; i <rowlimit; i++)
	xprintf(fp,"%7d \n",RowType(i));
	xprintf(fp,"indexarray\n");
	for (i = 0; i <rowlimit; i++)
	xprintf(fp,"%7d \n",indexarray[i]);
	xprintf(fp,"RowPtr\n");
	for (i=0;i<rowlimit;i++)
	xprintf(fp,"%7d \n",RowPtr[i]);
	xprintf(fp,"ColPtr\n");
	for (i=0;i<collimit;i++)
	xprintf(fp,"%7d \n",ColPtr[i]);
	xprintf(fp,"ColType\n");
	for (j = 0; j <collimit; j++)
	 xprintf(fp,"%7d \n",ColType(j));
	xprintf(fp,"Number\n");
	for (j = 0; j <collimit; j++)
	 xprintf(fp,"%7d %7d %7d %7d     %7d\n",Number(j,0),Number(j,1),Number(j,2),
		Number(j,3),Number(j,4));
	xprintf(fp,"ConstModulus\n");
	for (j = 0; j <collimit; j++)
	 xprintf(fp,"%7.3f \n",ConstModulus(j));
	xprintf(fp,"CondTest\n");
	for (j = 0; j <collimit; j++)
	 xprintf(fp,"%7.3f \n",CondTest(j));
	xprintf(fp,"CondModulus\n");
	for (j = 0; j <collimit; j++)
	 xprintf(fp,"%7.3f \n",CondModulus(j));
	xprintf(fp,"ConstTest\n");
	for (j = 0; j <collimit; j++)
	 xprintf(fp,"%7.3f \n",ConstTest(j));
	xprintf(fp,"Deltap\n");
	for (j = 0; j <collimit; j++)
	 xprintf(fp,"%7.3f \n",Deltap(j));
	xprintf(fp,"vector\n");
	for (j = 0; j <collimit; j++)
	 xprintf(fp,"%7.3f \n",vector[j]);
	xprintf(fp,"VarName\n");
	for (j = 0; j <collimit; j++)
	 xprintf(fp,"%7s \n",VarName(j));

}
	
	
void
dump8(void) {
	int inc;
	inc = 0;
	xprintf(fp,"dump8\n");
	while (inc < LastCol+20) {
		d8(inc,inc+20);
		inc = inc + 20;
	}
	d8(inc,LastCol);
}
	
void
d8(int FCol, int LCol)
{
	int i, j;
	double matint;

	for (j=0;j<8;j++) {
		xprintf (fp,"%d",j);
		for (i=FCol;i<LCol;i++)
		{
			matint = 1000.0* Matrix(i,j);
			if (fabs(matint) < 1.0E9)
				xprintf(fp,"%4d ",(int)matint);
		}
		xprintf(fp,"\n");
	}
	xprintf(fp,"\n");
}



void
printenvtoRes(FILE *fp)
{
	FITS *fitpnt;
	fitpnt = getenvtabpntr();
	xprintf(fp,"Contents of the Environment File for this Run: \n\n");
	if (fitpnt)
		fitswrite(fp, fitpnt);
}

void
printdate(FILE *fp)
{
	time_t ltime;

	time(&ltime);
	xprintf(fp,"\nTime of GaussFit Run:  %s\n",ctime(&ltime));

}

void
printmessage(FILE *fpoint)
{
	xprintf(fpoint,"\n***********************************");
	xprintf(fpoint,"***********************************\n");
	xprintf(fpoint,"If the input variances are real, the chi-square");
	xprintf(fpoint," is correct and should\nbe equivalent to the");
	xprintf(fpoint," degrees of freedom(DOF).  Otherwise, chi-square\n");
	xprintf(fpoint,"should be divided by a proportionality factor.");
	xprintf(fpoint,"\n***********************************");
	xprintf(fpoint,"***********************************\n");
}

