/*

	GaussFit - A System for Least Squares and Robust Estimation
	Source Code Copyright (C) 1987 by William H. Jefferys,
	Michael J. Fitzpatrick and Barbara E. McArthur
	All Rights Reserved.
*/
/* program Householder    */

/* Header file for Householder transformations */
#ifndef _HOUSEH_
#define _HOUSEH_
#ifdef __MWERKS__
#pragma once
#endif

#ifndef sgi
#define itrunc(x)          ((int)(x))     /* integer part of x */
#endif

#ifndef DBL_DIG
#define DBL_DIG    18	/* fractional significance IEEE standard */	
#endif

#define deltafn(i,j) (((i)==(j))?1:0)        /* Kronedcker delta */
#define sqr(x)            ((x)*(x))      /* square of x */
#define minval(x,y)       (((x)<=(y))?(x):(y)) /* minimum of 2 arguments */
#define maxval(x,y)       (((x)>=(y))?(x):(y)) /* maximum of 2 arguments */
#define RoundToZero(x,y)  ((fabs(x)<(y))?(0.0):(x))
/* 
	Rounds a number that has lost 
	significance  (i.e., is <y ) to zero
*/


typedef struct key
{
	char name[64];              /* name of column indexed  */
	int  col;                   /* col where info resides */
	int  type;                 /*  type of var */
} KEY;

#define MATSIZE 4			/* Max order of matrices for Weights */

typedef double MATRIX[MATSIZE][MATSIZE];   /* MATRIX typedef */
typedef double VECTOR[MATSIZE];            /* VECTOR typedef */
typedef int INDEX[MATSIZE];	/* arrays for "sort" of columns by pivot ability*/

double getdeltas();		
double Get_Sigma();		

#define Matrix(i,j)matrix[RowPtr[i]][ColPtr[j]] /* All arrays are alloc- */
#define RowType(i)rowtype[RowPtr[i]]/* ated dynamically and*/
#define ColType(i)coltype[ColPtr[i]]/* are accessed indirect-*/
#define Deltap(i) deltap[ColPtr[i]]/* ly through arrays*/
#define CondModulus(i)condmodulus[ColPtr[i]] /* ColPtr and RowPtr.*/
#define ConstModulus(i) constmodulus[ColPtr[i]]
#define ConstTest(i)consttest[ColPtr[i]]
#define CondTest(i)condtest[ColPtr[i]]
#define Number(i,j) number[ColPtr[i]][j]
#define NumberX(i) number[ColPtr[i]]
#define VarName(i)varname[ColPtr[i]]

#endif
